Index: res/res_agi.c
===================================================================
--- res/res_agi.c	(revision 98714)
+++ res/res_agi.c	(working copy)
@@ -1165,9 +1165,17 @@
 
 static int handle_setvariable(struct ast_channel *chan, AGI *agi, int argc, char **argv)
 {
-	if (argv[3])
-		pbx_builtin_setvar_helper(chan, argv[2], argv[3]);
-
+	char tmp[AGI_BUF_LEN] = "";
+	char *s = "";
+	if (argv[3]){
+		s = ast_strdupa(argv[3]);
+		if (strchr(s, '$') || strstr(s,"${") || strstr(s,"$[") || strstr(s,"$(")) {
+			pbx_substitute_variables_helper(chan, s, tmp, AGI_BUF_LEN - 1);
+		} else {
+			ast_copy_string(tmp, s, sizeof(tmp));
+		}
+		pbx_builtin_setvar_helper(chan, argv[2], tmp);
+	}
 	fdprintf(agi->fd, "200 result=1\n");
 	return RESULT_SUCCESS;
 }
